﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;
using Castle.Windsor;
using Rhino.Mocks;
using Castle.Facilities.FactorySupport;
using System.Web;
using Castle.MicroKernel.Registration;
using MysingleCase.Components;
using System.Web.Mvc;
using System.Reflection;
using Microsoft.Practices.ServiceLocation;
//using MysingleCase.Web;


namespace MbunitTest
{
    [TestFixture]
    public class BaseTest
    {
        public IWindsorContainer container;
        public MockRepository mocks;
        [SetUp]
        public void initialize()
        {
            container = new WindsorContainer();
            container.AddFacility<FactorySupportFacility>();
            mocks = new MockRepository();
            var httpcontextMock = mocks.DynamicMock<HttpContextBase>();
            var httprequsetMock = mocks.DynamicMock<HttpRequestBase>();
            Expect.Call(httpcontextMock.Request).Return(httprequsetMock);
            //Expect.Call(httprequsetMock.AppRelativeCurrentExecutionFilePath).Return("~/Home/Index");
            //Uri uri = new Uri("http://localhost/blackjacktry/Home/Index/5");
            Uri uri = new Uri("http://localhost/");
            string siteurl = "localhost";
            container.Register(AllTypes.Of<Controller>().FromAssembly(Assembly.GetExecutingAssembly()).Configure(c => c.LifeStyle.Transient.Named(c.Implementation.Name.ToLower())));
            container.Register(Component.For<HttpContextBase>().LifeStyle.PerThread.UsingFactoryMethod<HttpContextBase>(() => httpcontextMock));
 
            ServiceLocator.SetLocatorProvider(() => container.Resolve<IServiceLocator>());
            System.Web.Mvc.ControllerBuilder.Current.SetControllerFactory(new WindsorControllerFactory(container));
            IoC.Initialize(container);
        }
    }
}
