﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;
//using MysingleCase.Web;
using System.Web.Mvc;
using Castle.Windsor;
using MysingleCase.Components;
using Microsoft.Practices.ServiceLocation;
using Castle.Windsor.Configuration.Interpreters;
using Castle.Facilities.FactorySupport;
using System.Web;
using Castle.MicroKernel.Registration;
using System.Reflection;
using System.Collections;
using MysingleCase;
using System.Collections.Specialized;
using Rhino.Mocks;
using Rhino.Mocks.Constraints;
using MysingleCase.Models;
using MySingleCase;

namespace MbunitTest
{
    [TestFixture]
    public class HomeControllerTest:BaseTest
    {
        [Test]
        public void NewOrEditWithPostIDNotNullTest()
        {
            MockRepository mocks = new MockRepository();
            var users = mocks.DynamicMock<IUsers>();
            var posts = mocks.DynamicMock<INewsPosts>();
            var forums = mocks.DynamicMock<IForumSections>();
            HomeController controller = new HomeController(posts, forums, users);
            int postID = 2010;
            int userID = 111;
            int forumID = 215;
            var post = new NewsPost
            {
                PostID = postID,
                PostDate = DateTime.Now,
                UserName = "wyn",
                ForumID = forumID,
                Subject = "abcdefg",
                AuthorID = userID,
            };
            Expect.Call(posts.GetPost(postID, userID)).Return(post);
            mocks.ReplayAll();
            ViewResult result = controller.NewOrEdit(postID, forumID, userID) as ViewResult;
            mocks.VerifyAll();
            Assert.IsTrue((result.TempData["PostMode"]).ToString() == "EditPost", "fails");
            Assert.IsTrue(result.ViewData.Model != null, "fails");
            Assert.IsTrue(((NewsPost)(result.ViewData.Model)).Subject == "abcdefg", "fails");
        }
        [Test]
        public void NewOrEditWithPostIDNullTest()
        {
            MockRepository mocks = new MockRepository();
            var users = mocks.DynamicMock<IUsers>();
            var posts = mocks.DynamicMock<INewsPosts>();
            var forums = mocks.DynamicMock<IForumSections>();
            HomeController controller = new HomeController(posts, forums, users);
            int userID = 112;
            int forumID = 216;
            var forum = new ForumSection
            {
                SectionID = forumID,
                SectionName = "企业管理"
            };
            Expect.Call(forums.GetForumSection(forumID, userID)).Return(forum);
            mocks.ReplayAll();
            ViewResult result = controller.NewOrEdit(null, forumID, userID) as ViewResult;
            mocks.VerifyAll();
            Assert.IsTrue((result.TempData["PostMode"]).ToString() == "NewPost", "fails");
            Assert.IsTrue(result.ViewData.Model == null, "fails");
        }
    }
}
