﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MbUnit.Framework;
//using MysingleCase.Web;
using System.Web.Mvc;
using Castle.Windsor;
using MysingleCase.Components;
using Microsoft.Practices.ServiceLocation;
using Castle.Windsor.Configuration.Interpreters;
using Castle.Facilities.FactorySupport;
using System.Web;
using Castle.MicroKernel.Registration;
using System.Reflection;
using System.Collections;
using MysingleCase;
using System.Collections.Specialized;
using Rhino.Mocks;
using Rhino.Mocks.Constraints;
using MysingleCase.Models;
using MySingleCase;

namespace MbunitTest.FunctionTest
{
    [TestFixture]
    public class NewsPostTest:BaseTest
    {
        [Test]
        public void AddPostTest()
        {
            MockRepository mocks = new MockRepository();
            var posts = mocks.DynamicMock<INewsPosts>();
            var forums = mocks.DynamicMock<IForumSections>();
            var users = mocks.DynamicMock<IUsers>();
            var provider = mocks.DynamicMock<ForumDataProvider>();
            int postID = 1999;
            int forumID = 215;
            int userID = 123;
            DateTime postDate = DateTime.Now;
            string body = "afeifeiao";
            var post = new NewsPost
            {
                PostID = postID,
                Body = body,
                PostDate = postDate,
                ForumID = forumID,
                AuthorID = userID

            };
            var user = new User
            {
                UserID = userID,
                UserName = "wyn",
                TotalPosts = 100
            };
            Expect.Call(posts.GetPost(postID, userID)).Return(post);
            Expect.Call(users.GetUser(userID)).Return(user);
            
            users.ForumDataProvider = provider;
            posts.ForumDataProvider = provider;
            mocks.ReplayAll();
            NewsPost posttest = posts.GetPost(postID, userID);
            User usertest=users.GetUser(userID);
           // mocks.VerifyAll();
            Assert.IsTrue(posttest != null, "fails");
            Assert.IsTrue(posttest.AuthorID == userID, "fails");
            Assert.IsTrue(posttest.Body == body, "fails");
            Assert.IsTrue(usertest.TotalPosts == 100, "fails");
        }
    }
}
