﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Collections;
using System.Text.RegularExpressions;
using MysingleCase.Components;
using MysingleCase.Models;

namespace MySingleCase
{
    public partial class HomeController:Controller
    {
        private IForumSections forumSections;
        public IForumSections ForumSections
        {
            get
            {
                if (forumSections == null)
                {
                    throw new InvalidOperationException("The forumSections has not been initialized!");
                }
                return forumSections;
            }
        }
        private INewsPosts posts;
        public INewsPosts Posts
        {
            get
            {
                if (posts == null)
                {
                    throw new InvalidOperationException("The posts has not been initialized!");
                }
                return posts;
            }
        }
        private IUsers users;
        public IUsers Users
        {
            get
            {
                if (users == null)
                {
                    throw new InvalidOperationException("The users has not been initialized!");
                }
                return users;
            }
        }

        public HomeController()
        {
            this.posts = IoC.Resolve<INewsPosts>();
            this.forumSections = IoC.Resolve<IForumSections>();
            this.users = IoC.Resolve<IUsers>();
        }
        public HomeController(INewsPosts newsposts, IForumSections forumsections, IUsers users)
        {
            this.posts = newsposts;
            this.forumSections = forumsections;
            this.users = users;
        }
        CreateEditPostMode PostMode;
        public virtual ActionResult Index()
        {
            return View();
        }
        public virtual ActionResult NewOrEdit(int? postID, int? forumID,int ? userID)
        {
            NewsPost postReplyingTo = new NewsPost();
            ForumSection forum = new ForumSection();
            int postId = postID ?? 0;
            int forumId = forumID ?? 0;
            int userId = userID ?? 0;
            if ((forumId < 0) && (postId < 0))
            {
                throw new Exception("An Error Named PostNotFound Occurred");
            }
            if (postId > 0)
            {
                postReplyingTo = posts.GetPost(postId,userId);
                if (postReplyingTo == null)
                {
                    throw new Exception("An Error Named PostNotFound Occurred");
                }
                PostMode = CreateEditPostMode.EditPost;
            }
            else if (forumId > 0)
            {
                forum = (ForumSection)forumSections.GetForumSection(forumId, userId);
                if (forum == null)
                {
                    throw new Exception("An Error Named ForumNotFound Occurred");
                }
                PostMode = CreateEditPostMode.NewPost;
            }

            TempData["PostMode"] = PostMode;
            //这里如果要加权限的话应该需要处理。
            if (postReplyingTo.PostID == 0)
            {
                return View("NewOrEdit");
            }
            else
                return View("NewOrEdit", postReplyingTo);
       }

    }
}
