﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Collections;
using System.ComponentModel;
using System.Web.Mvc;
using System.Web.Routing;
using Castle.Windsor;
using Microsoft.Practices.ServiceLocation;
using MysingleCase.Components;

namespace MySingleCase
{
    public class Global : System.Web.HttpApplication
    {
        private static IWindsorContainer container;

        public IWindsorContainer Container
        {
            get { return container; }
        }
        private System.ComponentModel.IContainer components = null;
        public Global()
        {
            InitializeComponent();
        }
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");
            routes.IgnoreRoute("{resource}.aspx/{*pathInfo}");
            routes.IgnoreRoute("{resource}.ico/{*pathInfo}");

            //routes.MapAreas("{controller}/{action}/{id}",
            //   "BlackJack.Web",
            //   new[] { "Experts", "News" });

            //routes.MapRootArea("{controller}/{action}/{id}",
            //    "BlackJack.Web",
            //    new { controller = "Home", action = "Index", id = "" });

            routes.MapRoute(
               "Default",
                // Route name
               "{controller}/{action}/{id}",
                // URL with parameters
               new { controller = "Home", action = "Index", id = "" }
                // Parameter defaults
                );
 
        }
        protected virtual void InitializeWindsor()
        {
            if (container == null)
            {
                // create a new Windsor Container
                container = ContainerBuilder.Build("Configuration\\Windsor.config");
                //2010-03-07 王华杰 remove
                //WcfConfiguration.ConfigureContainer(container);

                ServiceLocator.SetLocatorProvider(() => container.Resolve<IServiceLocator>());
                // set the controller factory to the Windsor controller factory (in MVC Contrib)
                System.Web.Mvc.ControllerBuilder.Current.SetControllerFactory(new WindsorControllerFactory(container));

                IoC.Initialize(container);
            }
        }
        protected void Application_Start(object sender, EventArgs e)
        {
            //ViewEngines.Engines.Clear();
            //ViewEngines.Engines.Add(new AreaViewEngine());
            RegisterRoutes(RouteTable.Routes);
            InitializeWindsor();
        }

        protected void Session_Start(object sender, EventArgs e)
        {

        }

        protected void Application_BeginRequest(object sender, EventArgs e)
        {

        }

        protected void Application_AuthenticateRequest(object sender, EventArgs e)
        {

        }

        protected void Application_Error(object sender, EventArgs e)
        {

        }

        protected void Session_End(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {
            container.Dispose();
        }
        #region Web 窗体设计器生成的代码
        /// <summary>
        /// 设计器支持所需的方法 - 不要使用代码编辑器修改
        /// 此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
        }
        #endregion
    }
}