﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Castle.Windsor;
using Castle.Windsor.Configuration.Interpreters;
using Castle.MicroKernel.Registration;
using System.Reflection;
using Castle.Facilities.FactorySupport;
using System.Web.Mvc;
using MysingleCase.Models;

namespace MySingleCase
{
    public static class ContainerBuilder
    {
        public static IWindsorContainer Build(string configPath)
        {
            var container = new WindsorContainer(new XmlInterpreter(configPath));
            container.Register(AllTypes
                                   .Of<Controller>()
                                   .FromAssembly(Assembly.GetExecutingAssembly())
                                   .Configure(c => c.LifeStyle.Transient.Named(c.Implementation.Name.ToLower())));
            container.Register(Component.For<IUsers>().LifeStyle.Singleton.ImplementedBy<Users>());
            container.Register(Component.For<INewsPosts>().LifeStyle.Singleton.ImplementedBy<NewsPosts>());
            container.Register(Component.For<IForumSections>().LifeStyle.Singleton.ImplementedBy<ForumSections>());
            //container.AddFacility<FactorySupportFacility>();
            // container.Register(Component.For<IUsers>().LifeStyle.Singleton.ImplementedBy<Users>());
            //container.Register(Component.For<IRoles>().LifeStyle.Singleton.ImplementedBy<Roles>());
            //container.Register(Component.For<IFormatter>().LifeStyle.Singleton.ImplementedBy<Formatter>());
            //container.Register(Component.For<IEmails>().LifeStyle.Singleton.ImplementedBy<Emails>());
            //container.Register(Component.For<IPosts>().LifeStyle.Singleton.ImplementedBy<Posts>());
            //container.Register(Component.For<IThreads>().LifeStyle.Singleton.ImplementedBy<Threads>());

            //container.Register(Component.For<ISections>().LifeStyle.Singleton.ImplementedBy<Sections>());
            //container.Register(Component.For<IForumGroups>().LifeStyle.Singleton.ImplementedBy<ForumGroups>());
            //container.Register(Component.For<IForumSections>().LifeStyle.Singleton.ImplementedBy<ForumSections>());
            //container.Register(Component.For<IGroups>().LifeStyle.Singleton.ImplementedBy<Groups>());
            //container.Register(Component.For<IFunctionModules>().LifeStyle.Singleton.ImplementedBy<FunctionModules>());
            //container.Register(Component.For<IModerate>().LifeStyle.Singleton.ImplementedBy<Moderate>());

            return container;
        }

    }
}
