﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

 

namespace MysingleCase.Models
{
    public class NewsPosts:INewsPosts
    {
        private ForumDataProvider dp = ForumDataProvider.Instance();
        public ForumDataProvider ForumDataProvider
        {
            set { dp = value; }
        }
        private IUsers users;
        public IUsers Users
        {
            get
            {
                if (users == null)
                {
                    throw new InvalidOperationException("The users has not been initialized!");
                }
                return users;
            }
        }
        public NewsPosts() { }
        public NewsPosts(IUsers users)
        {
            this.users = users;
        }
        public NewsPost AddPost(NewsPost post, int userID)
        {   
            //2008/03/05 刘政敏
            User user = users.GetUser(userID);
            int totalposts = user.TotalPosts;
            NewsPost newPost = dp.AddPost(post, userID);
            user.TotalPosts = totalposts + 1;
            users.UpdateUser(user);
            return newPost;
        }
        public NewsPost GetPost(int postID, int userID)
        {
            NewsPost newPost = dp.GetPost(postID, userID);
            return newPost;
        }
    }
}
