﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MysingleCase.Models;
using GotDotNet.ApplicationBlocks.Data;
using System.Data.SqlClient;
using System.Data;
using MysingleCase.Components;

namespace MysingleCase.Data
{
    public class SqlForumDataProvider:ForumDataProvider
    {
        private AdoHelper helper = AdoHelper.CreateHelper("misapp");
        // #region SettingsID
        //protected int GetSettingsID()
        //{
        //    return sqlHelper.GetSettingsID();
        //}

        //protected SqlParameter SettingsIDParameter()
        //{
        //    SqlParameter p = new SqlParameter("@SettingsID", SqlDbType.Int);
        //    p.Value = GetSettingsID();
        //    return p;
        //}
        //#endregion

        #region Member variables
        protected string databaseOwner = "dbo";	// overwrite in web.config
        string connectionString = null;
        //ProviderHelper sqlHelper = null;
        #endregion

        #region Constructor
        public SqlForumDataProvider(string databaseOwner, string connectionString)
        {
 
            this.connectionString = connectionString;
 
            this.databaseOwner = databaseOwner;

            //sqlHelper = ProviderHelper.Instance();

        }
        #endregion

        #region helpers
        protected SqlConnection GetSqlConnection()
        {

            try
            {
                return new SqlConnection(ConnectionString);
            }
            catch
            {
                throw new Exception("SQL Connection String is invalid.");
            }

        }

        public string ConnectionString
        {
            get
            {
                return connectionString;
            }
            set
            {
                connectionString = value;
            }
        }
        #endregion


        public override NewsPost AddPost(NewsPost post, int userID)
        {
            int postID = -1;
            SqlCommand myCommand;
     
            using (SqlConnection myConnection = GetSqlConnection())
            {
                 
                myCommand = new SqlCommand(databaseOwner + ".cs_Post_CreateUpdate", myConnection);
                myCommand.CommandType = CommandType.StoredProcedure;
 
               
                myCommand.Parameters.Add("@ForumID", SqlDbType.Int).Value = post.ForumID;
  
                myCommand.Parameters.Add("@Subject", SqlDbType.NVarChar, 256).Value = post.Subject;
                myCommand.Parameters.Add("@UserID", SqlDbType.Int).Value = userID;
                myCommand.Parameters.Add("@Body", SqlDbType.NText).Value = post.Body;
 
                myCommand.Parameters.Add("@PostID", SqlDbType.Int).Direction = ParameterDirection.Output;
                
                if (userID == 0)
                {
                    myCommand.Parameters.Add("@PostAuthor", SqlDbType.NVarChar, 128).Value = post.UserName;
                }

 
                myCommand.Parameters.Add("@StickyDate", SqlDbType.DateTime).Value = DateTime.Now;
 

                myConnection.Open();
                myCommand.ExecuteNonQuery();
                myConnection.Close();
 
                try
                {
                    postID = (int)myCommand.Parameters["@PostID"].Value;
                }
                catch { }

                if (postID == -1)
                {
                    throw new Exception("An error of PostDuplicate Occurred");
                }

                return GetPost(postID, userID);
            }
        }
        public override NewsPost GetPost(int postID, int userID)
        {
     
            using (SqlConnection myConnection = GetSqlConnection())
            {
                SqlCommand myCommand = new SqlCommand(databaseOwner + ".cs_forums_Post", myConnection);
                myCommand.CommandType = CommandType.StoredProcedure;
                myCommand.Parameters.Add("@PostID", SqlDbType.Int).Value = postID;
                myCommand.Parameters.Add("@UserID", SqlDbType.Int).Value = userID;
               
                myConnection.Open();
                NewsPost p = null;
                using (SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection))
                {

                    if (!dr.Read())
                    {
                        dr.Close();
                        myConnection.Close();
                        throw new Exception("An Error Named PostNotFound Occurred");
                    }

                    else
                    {
                        p.AuthorID = Convert.ToInt32(dr["AuthorID"].ToString());
                        p.Body = dr["Body"].ToString();
                        p.ForumID = Convert.ToInt32(dr["ForumID"].ToString());
                        p.PostDate = Convert.ToDateTime(dr["PostDate"]);
                        p.PostID = Convert.ToInt32(dr["PostID"].ToString());
                        p.Subject = dr["Subject"].ToString();
                        p.UserName = dr["UserName"].ToString();
                        dr.Close();
                    }
                }
                myConnection.Close();
                return p;
            }
        }
        public override ForumSection GetForumSection(int forumID, int userID)
        {
            using (SqlConnection myConnection = GetSqlConnection())
            {
                SqlCommand myCommand = new SqlCommand(databaseOwner + ".cs_Forum_Get", myConnection);
                myCommand.CommandType = CommandType.StoredProcedure;

                ForumSection forumsection = new ForumSection();


                myCommand.Parameters.Add("@ForumID", SqlDbType.Int).Value = forumID;// ApplicationType.News;
                myCommand.Parameters.Add("@UserID", SqlDbType.Int).Value = userID;
 
                myConnection.Open();
                using (SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection))
                {
                    while (dr.Read())
                    {
                        forumsection.SectionID = Convert.ToInt32(dr["SectionID"].ToString());
                        forumsection.SectionName = dr["SectionName"].ToString();
                    }
                    //这里如果要加权限的话需要加上。
                    dr.Close();
                }
                myConnection.Close();

                return forumsection;
            }
        }
        public override User UpdateUser(User user)
        {
            using (SqlConnection myConnection = GetSqlConnection())
            {
                SqlCommand myCommand = new SqlCommand(databaseOwner + ".cs_User_Update", myConnection);
                myCommand.CommandType = CommandType.StoredProcedure;

                myCommand.Parameters.Add("@UserID", SqlDbType.Int).Value = user.UserID;
                myCommand.Parameters.Add("@UserName", SqlDbType.Int, 4).Value = user.UserName;
                myCommand.Parameters.Add("@Email", SqlDbType.NVarChar, 256).Value = user.Email;
                myCommand.Parameters.Add("@Password", SqlDbType.NText).Value = user.Password;
                myCommand.Parameters.Add("@TotalPosts", SqlDbType.NText).Value = user.TotalPosts;
                myConnection.Open();
                myCommand.ExecuteNonQuery();
                myConnection.Close();


                return GetUser(user.UserID);
            }
        }
        public override User GetUser(int userID)
        {
            using (SqlConnection myConnection = GetSqlConnection())
            {
                SqlCommand myCommand = new SqlCommand(databaseOwner + ".cs_User_Get", myConnection);
                myCommand.CommandType = CommandType.StoredProcedure;

                User user = new User();
                myCommand.Parameters.Add("@UserID", SqlDbType.Int).Value = userID;// ApplicationType.News;

                myConnection.Open();
                using (SqlDataReader dr = myCommand.ExecuteReader(CommandBehavior.CloseConnection))
                {
                    while (dr.Read())
                    {
                        user.Email = dr["Email"].ToString();
                        user.Password = dr["Password"].ToString();
                        user.TotalPosts = Convert.ToInt32(dr["TotalPosts"].ToString());
                        user.UserID = Convert.ToInt32(dr["UserID"].ToString());
                        user.UserName = dr["UserName"].ToString();
                    }
                    //这里如果要加权限的话需要加上。
                    dr.Close();
                }
                myConnection.Close();

                return user;
            }
        }
    }
}
